/*******************************************************************************
* File Name: USBFS_1_descr.c
* Version 1.60
*
* Description:
*  USB descriptors and storage.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
********************************************************************************/

#include "USBFS_1.h"


/*******************************************************************************
*  User supplied descriptors.  If you want to specify your own descriptors,
*  remove the comments around the define USER_SUPPLIED_DESCRIPTORS below and
*  add your descriptors.
********************************************************************************/
/* `#START USER_DESCRIPTORS_DECLARATIONS` Place your declaration here */

/* `#END` */


/***************************************
*  USB Customizer Generated Descriptors
***************************************/

#if !defined(USER_SUPPLIED_DESCRIPTORS)
    /*********************************************************************
 Device Descriptors
 *********************************************************************/
uint8 CYCODE USBFS_1_DEVICE0_DESCR[] = {
/* Descriptor Length                       */ 0x12u,
/* DescriptorType: DEVICE                  */ 0x01u,
/* bcdUSB (ver 2.0)                        */ 0x00u, 0x02u,
/* bDeviceClass                            */ 0x00u,
/* bDeviceSubClass                         */ 0x00u,
/* bDeviceProtocol                         */ 0x00u,
/* bMaxPacketSize0                         */ 0x08u,
/* idVendor                                */ 0x11u, 0x11u,
/* idProduct                               */ 0x32u, 0x33u,
/* bcdDevice                               */ 0x00u, 0x00u,
/* iManufacturer                           */ 0x02u,
/* iProduct                                */ 0x01u,
/* iSerialNumber                           */ 0x00u,
/* bNumConfigurations                      */ 0x01u
};
/*********************************************************************
 Config Descriptor  
 *********************************************************************/
uint8 CYCODE USBFS_1_DEVICE0_CONFIGURATION0_DESCR[] = {
/*  Config Descriptor Length               */ 0x09u,
/*  DescriptorType: CONFIG                 */ 0x02u,
/*  wTotalLength                           */ 0x22u, 0x00u,
/*  bNumInterfaces                         */ 0x01u,
/*  bConfigurationValue                    */ 0x01u,
/*  iConfiguration                         */ 0x00u,
/*  bmAttributes                           */ 0xA0u,
/*  bMaxPower                              */ 0x32u,
/*********************************************************************
 Interface Descriptor
 *********************************************************************/
/*  Interface Descriptor Length            */ 0x09u,
/*  DescriptorType: INTERFACE              */ 0x04u,
/*  bInterfaceNumber                       */ 0x00u,
/*  bAlternateSetting                      */ 0x00u,
/*  bNumEndpoints                          */ 0x01u,
/*  bInterfaceClass                        */ 0x03u,
/*  bInterfaceSubClass                     */ 0x00u,
/*  bInterfaceProtocol                     */ 0x00u,
/*  iInterface                             */ 0x00u,
/*********************************************************************
 HID Class Descriptor
 *********************************************************************/
/*  HID Class Descriptor Length            */ 0x09u,
/*  DescriptorType: HID_CLASS              */ 0x21u,
/*  bcdHID                                 */ 0x11u, 0x01u,
/*  bCountryCode                           */ 0x00u,
/*  bNumDescriptors                        */ 0x01u,
/*  bDescriptorType                        */ 0x22u,
/*  wDescriptorLength (LSB)                */ USBFS_1_HID_RPT_1_SIZE_LSB,
/*  wDescriptorLength (MSB)                */ USBFS_1_HID_RPT_1_SIZE_MSB,
/*********************************************************************
 Endpoint Descriptor
 *********************************************************************/
/*  Endpoint Descriptor Length             */ 0x07u,
/*  DescriptorType: ENDPOINT               */ 0x05u,
/*  bEndpointAddress                       */ 0x81u,
/*  bmAttributes                           */ 0x03u,
/*  wMaxPacketSize                         */ 0x10u, 0x00u,
/*  bInterval                              */ 0x01u
};

    /*********************************************************************
 String Descriptor Table
 *********************************************************************/
uint8 CYCODE USBFS_1_STRING_DESCRIPTORS[] = {
/*********************************************************************
 Language ID Descriptor
 *********************************************************************/
/* Descriptor Length                       */ 0x04u,
 /* DescriptorType: STRING                  */ 0x03u,
 /* Language Id                             */ 0x09u, 0x04u,
/*********************************************************************
 String Descriptor: "Two points"
 *********************************************************************/
/* Descriptor Length                       */ 0x16u,
/* DescriptorType: STRING                  */ 0x03u,
 'T', 0,'w', 0,'o', 0,' ', 0,'p', 0,'o', 0,'i', 0,'n', 0,'t', 0,'s', 0,
/*********************************************************************
 String Descriptor: "PSoC USB Win7"
 *********************************************************************/
/* Descriptor Length                       */ 0x1Cu,
/* DescriptorType: STRING                  */ 0x03u,
 'P', 0,'S', 0,'o', 0,'C', 0,' ', 0,'U', 0,'S', 0,'B', 0,' ', 0,'W', 0
,'i', 0,'n', 0,'7', 0,
/*********************************************************************/
/* Marks the end of the list.              */ 0x00u};
/*********************************************************************/

    
    /*********************************************************************
 HID Report Descriptor: Win7 Multi touch
 *********************************************************************/
uint8 CYCODE USBFS_1_HIDREPORT_DESCRIPTOR1[] = {
/*  Descriptor Size (Not part of descriptor)*/ USBFS_1_HID_RPT_1_SIZE_LSB,
USBFS_1_HID_RPT_1_SIZE_MSB,
/* USAGE_PAGE                              */ 0x05u, 0x0Du, 
/* USAGE                                   */ 0x09u, 0x04u, 
/* COLLECTION                              */ 0xA1u, 0x01u, 
/* REPORT_ID                               */ 0x85u, 0x01u, 
/* USAGE                                   */ 0x09u, 0x22u, 
/* COLLECTION                              */ 0xA1u, 0x02u, 
/* USAGE                                   */ 0x09u, 0x42u, 
/* LOGICAL_MINIMUM                         */ 0x15u, 0x00u, 
/* LOGICAL_MAXIMUM                         */ 0x25u, 0x01u, 
/* REPORT_SIZE                             */ 0x75u, 0x01u, 
/* REPORT_COUNT                            */ 0x95u, 0x01u, 
/* INPUT                                   */ 0x81u, 0x02u, 
/* USAGE                                   */ 0x09u, 0x32u, 
/* INPUT                                   */ 0x81u, 0x02u, 
/* REPORT_COUNT                            */ 0x95u, 0x06u, 
/* INPUT                                   */ 0x81u, 0x03u, 
/* REPORT_SIZE                             */ 0x75u, 0x08u, 
/* CUSTOM                                  */ 0x09u, 0x51u, 
/* REPORT_COUNT                            */ 0x95u, 0x01u, 
/* INPUT                                   */ 0x81u, 0x02u, 
/* USAGE_PAGE                              */ 0x05u, 0x01u, 
/* LOGICAL_MAXIMUM                         */ 0x26u, 0xFFu, 0x0Fu, 
/* REPORT_SIZE                             */ 0x75u, 0x10u, 
/* UNIT_EXPONENT                           */ 0x55u, 0x00u, 
/* UNIT                                    */ 0x65u, 0x00u, 
/* USAGE                                   */ 0x09u, 0x30u, 
/* PHYSICAL_MINIMUM                        */ 0x35u, 0x00u, 
/* PHYSICAL_MAXIMUM                        */ 0x45u, 0x00u, 
/* INPUT                                   */ 0x81u, 0x02u, 
/* PHYSICAL_MAXIMUM                        */ 0x45u, 0x00u, 
/* USAGE                                   */ 0x09u, 0x31u, 
/* INPUT                                   */ 0x81u, 0x02u, 
/* END_COLLECTION                          */ 0xC0u, 
/* COLLECTION                              */ 0xA1u, 0x02u, 
/* USAGE_PAGE                              */ 0x05u, 0x0Du, 
/* USAGE                                   */ 0x09u, 0x42u, 
/* LOGICAL_MINIMUM                         */ 0x15u, 0x00u, 
/* LOGICAL_MAXIMUM                         */ 0x25u, 0x01u, 
/* REPORT_SIZE                             */ 0x75u, 0x01u, 
/* REPORT_COUNT                            */ 0x95u, 0x01u, 
/* INPUT                                   */ 0x81u, 0x02u, 
/* USAGE                                   */ 0x09u, 0x32u, 
/* INPUT                                   */ 0x81u, 0x02u, 
/* REPORT_COUNT                            */ 0x95u, 0x06u, 
/* INPUT                                   */ 0x81u, 0x03u, 
/* REPORT_SIZE                             */ 0x75u, 0x08u, 
/* CUSTOM                                  */ 0x09u, 0x51u, 
/* REPORT_COUNT                            */ 0x95u, 0x01u, 
/* INPUT                                   */ 0x81u, 0x02u, 
/* USAGE_PAGE                              */ 0x05u, 0x01u, 
/* LOGICAL_MAXIMUM                         */ 0x26u, 0xFFu, 0x0Fu, 
/* REPORT_SIZE                             */ 0x75u, 0x10u, 
/* UNIT_EXPONENT                           */ 0x55u, 0x00u, 
/* UNIT                                    */ 0x65u, 0x00u, 
/* USAGE                                   */ 0x09u, 0x30u, 
/* PHYSICAL_MINIMUM                        */ 0x35u, 0x00u, 
/* PHYSICAL_MAXIMUM                        */ 0x45u, 0x00u, 
/* INPUT                                   */ 0x81u, 0x02u, 
/* PHYSICAL_MAXIMUM                        */ 0x45u, 0x00u, 
/* USAGE                                   */ 0x09u, 0x31u, 
/* INPUT                                   */ 0x81u, 0x02u, 
/* END_COLLECTION                          */ 0xC0u, 
/* USAGE_PAGE                              */ 0x05u, 0x0Du, 
/* CUSTOM                                  */ 0x09u, 0x54u, 
/* REPORT_COUNT                            */ 0x95u, 0x01u, 
/* REPORT_SIZE                             */ 0x75u, 0x08u, 
/* LOGICAL_MINIMUM                         */ 0x15u, 0x00u, 
/* LOGICAL_MAXIMUM                         */ 0x25u, 0x08u, 
/* INPUT                                   */ 0x81u, 0x02u, 
/* REPORT_ID                               */ 0x85u, 0x02u, 
/* CUSTOM                                  */ 0x09u, 0x55u, 
/* FEATURE                                 */ 0xB1u, 0x02u, 
/* END_COLLECTION                          */ 0xC0u, 
/*********************************************************************/
/* End of the HID Report Descriptor        */ 0x00u, 0x00u};
/*********************************************************************/

    #if !defined(USER_DEFINE_USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_HID_RPT_STORAGE)
/*********************************************************************
 HID Input Report Storage
 *********************************************************************/
T_USBFS_1_XFER_STATUS_BLOCK USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_IN_RPT_SCB;
uint8 USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_IN_BUF[USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_IN_BUF_SIZE];

/*********************************************************************
 HID Input Report TD Table
 *********************************************************************/
T_USBFS_1_TD CYCODE USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_IN_RPT_TABLE[] = {
    {USBFS_1_NULL,     &USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_IN_BUF[0], USBFS_1_NULL},
    {USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_IN_BUF_SIZE,     &USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_IN_BUF[0],     &USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_IN_RPT_SCB}
};
/*********************************************************************
 HID Feature Report Storage
 *********************************************************************/
T_USBFS_1_XFER_STATUS_BLOCK USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_FEATURE_RPT_SCB;
uint8 USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_FEATURE_BUF[USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_FEATURE_BUF_SIZE];

/*********************************************************************
 HID Feature Report TD Table
 *********************************************************************/
T_USBFS_1_TD CYCODE USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_FEATURE_RPT_TABLE[] = {
    {USBFS_1_NULL,     &USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_IN_BUF[0], USBFS_1_NULL},
    {USBFS_1_NULL,     &USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_IN_BUF[0], USBFS_1_NULL},
    {USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_FEATURE_BUF_SIZE,     &USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_FEATURE_BUF[0],     &USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_FEATURE_RPT_SCB}
};
/*********************************************************************
 HID Report Look Up Table          This table has four entries:
                                         IN Report Table
                                         OUT Report Table
                                         Feature Report Table
                                         HID Report Descriptor
                                         HID Class Descriptor
 *********************************************************************/
T_USBFS_1_LUT CYCODE USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_TABLE[] = {
    {0x02u,     &USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_IN_RPT_TABLE},
    {0x00u,    USBFS_1_NULL},
    {0x03u,     &USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_FEATURE_RPT_TABLE},
    {0x01u,     &USBFS_1_HIDREPORT_DESCRIPTOR1[0]},
    {0x01u,     &USBFS_1_DEVICE0_CONFIGURATION0_DESCR[18]}
};
#endif /* USER_DEFINE_USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_HID_RPT_STORAGE */

    /*********************************************************************
 Interface Dispatch Table -- Points to the Class Dispatch Tables
 *********************************************************************/
T_USBFS_1_LUT CYCODE USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_TABLE[] = {
    {USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_COUNT, 
    &USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_ALTERNATE0_HID_TABLE}
};
/*********************************************************************
  Endpoint Setting Table -- This table contain the endpoint setting
                            for each endpoint in the configuration.  It
                            contains the necessary information to
                            configure the endpoint hardware for each
                            interface and alternate setting.
  *********************************************************************/
T_USBFS_1_EP_SETTINGS_BLOCK CYCODE USBFS_1_DEVICE0_CONFIGURATION0_EP_SETTINGS_TABLE[] = {
/* IFC  ALT    EPAddr bmAttr MaxPktSize BufferType ********************/
{0x00u, 0x00u, 0x81u, 0x03u, 0x0010u,   0x00u}
};
/*********************************************************************
 Config Dispatch Table -- Points to the Config Descriptor and each of
                          and endpoint setup table and to each interface 
                          table if it specifies a USB Class 
 *********************************************************************/
T_USBFS_1_LUT CYCODE USBFS_1_DEVICE0_CONFIGURATION0_TABLE[] = {
    {0x01u,     &USBFS_1_DEVICE0_CONFIGURATION0_DESCR},
    {0x01u,     &USBFS_1_DEVICE0_CONFIGURATION0_EP_SETTINGS_TABLE},
    {0x01u,     &USBFS_1_DEVICE0_CONFIGURATION0_INTERFACE0_TABLE}
};
/*********************************************************************
 Device Dispatch Table -- Points to the Device Descriptor and each of
                          and Configuration Tables for this Device 
 *********************************************************************/
T_USBFS_1_LUT CYCODE USBFS_1_DEVICE0_TABLE[] = {
    {0x01u,     &USBFS_1_DEVICE0_DESCR},
    {0x01u,     &USBFS_1_DEVICE0_CONFIGURATION0_TABLE}
};
/*********************************************************************
 Device Table -- Indexed by the device number.
 *********************************************************************/
T_USBFS_1_LUT CYCODE USBFS_1_TABLE[] = {
    {0x01u,     &USBFS_1_DEVICE0_TABLE}
};

#endif /* USER_SUPPLIED_DESCRIPTORS */

#if defined(USBFS_1_ENABLE_MSOS_STRING)

    /*******************************************************************************
    *  USB Microsoft OS String Descriptor
    *  "MSFT" identifies a Microsoft host
    *  "100" specifies version 1.00
    *  USBFS_1_GET_EXTENDED_CONFIG_DESCRIPTOR becomes the bRequest value
    *  in a host vendor device/class request
    *******************************************************************************/

    uint8 CYCODE USBFS_1_MSOS_DESCRIPTOR[] = {
    /* Descriptor Length                       */   0x12u,
    /* DescriptorType: STRING                  */   0x03u,
    /* qwSignature */                               'M', 0, 'S', 0, 'F', 0, 'T', 0, '1', 0, '0', 0, '0', 0,
    /* bMS_VendorCode:                         */   USBFS_1_GET_EXTENDED_CONFIG_DESCRIPTOR,
    /* bPad                                    */   0x00u
    };

    /* Extended Configuration Descriptor */

    uint8 CYCODE USBFS_1_MSOS_CONFIGURATION_DESCR[] = {
    /*  Length of the descriptor 4 bytes       */   0x28u, 0x00u, 0x00u, 0x00u,
    /*  Version of the descriptor 2 bytes      */   0x00u, 0x01u,
    /*  wIndex - Fixed:INDEX_CONFIG_DESCRIPTOR */   0x04u, 0x00u,
    /*  bCount - Count of device functions.    */   0x01u,
    /*  Reserved : 7 bytes                     */   0x00u, 0x00u, 0x00u, 0x00u, 0x00u, 0x00u, 0x00u,
    /*  bFirstInterfaceNumber                  */   0x00u,
    /*  Reserved                               */   0x01u,
    /*  compatibleID    - "CYUSB\0\0"          */   'C', 'Y', 'U', 'S', 'B', 0x00, 0x00u, 0x00u,
    /*  subcompatibleID - "00001\0\0"          */   '0', '0', '0', '0', '1', 0x00, 0x00u, 0x00u,
    /*  Reserved : 6 bytes                     */   0x00u, 0x00u, 0x00u, 0x00u, 0x00u, 0x00u
    };
    
#endif /* USBFS_1_ENABLE_MSOS_STRING */


/* [] END OF FILE */
