/*******************************************************************************
* File Name: CLK_to_CP.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_CLK_to_CP_H) /* Pins CLK_to_CP_H */
#define CY_PINS_CLK_to_CP_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "CLK_to_CP_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    CLK_to_CP_Write(uint8 value) ;
void    CLK_to_CP_SetDriveMode(uint8 mode) ;
uint8   CLK_to_CP_ReadDataReg(void) ;
uint8   CLK_to_CP_Read(void) ;
uint8   CLK_to_CP_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define CLK_to_CP_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define CLK_to_CP_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define CLK_to_CP_DM_RES_UP          PIN_DM_RES_UP
#define CLK_to_CP_DM_RES_DWN         PIN_DM_RES_DWN
#define CLK_to_CP_DM_OD_LO           PIN_DM_OD_LO
#define CLK_to_CP_DM_OD_HI           PIN_DM_OD_HI
#define CLK_to_CP_DM_STRONG          PIN_DM_STRONG
#define CLK_to_CP_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define CLK_to_CP_MASK               CLK_to_CP__MASK
#define CLK_to_CP_SHIFT              CLK_to_CP__SHIFT
#define CLK_to_CP_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define CLK_to_CP_PS                     (* (reg8 *) CLK_to_CP__PS)
/* Data Register */
#define CLK_to_CP_DR                     (* (reg8 *) CLK_to_CP__DR)
/* Port Number */
#define CLK_to_CP_PRT_NUM                (* (reg8 *) CLK_to_CP__PRT) 
/* Connect to Analog Globals */                                                  
#define CLK_to_CP_AG                     (* (reg8 *) CLK_to_CP__AG)                       
/* Analog MUX bux enable */
#define CLK_to_CP_AMUX                   (* (reg8 *) CLK_to_CP__AMUX) 
/* Bidirectional Enable */                                                        
#define CLK_to_CP_BIE                    (* (reg8 *) CLK_to_CP__BIE)
/* Bit-mask for Aliased Register Access */
#define CLK_to_CP_BIT_MASK               (* (reg8 *) CLK_to_CP__BIT_MASK)
/* Bypass Enable */
#define CLK_to_CP_BYP                    (* (reg8 *) CLK_to_CP__BYP)
/* Port wide control signals */                                                   
#define CLK_to_CP_CTL                    (* (reg8 *) CLK_to_CP__CTL)
/* Drive Modes */
#define CLK_to_CP_DM0                    (* (reg8 *) CLK_to_CP__DM0) 
#define CLK_to_CP_DM1                    (* (reg8 *) CLK_to_CP__DM1)
#define CLK_to_CP_DM2                    (* (reg8 *) CLK_to_CP__DM2) 
/* Input Buffer Disable Override */
#define CLK_to_CP_INP_DIS                (* (reg8 *) CLK_to_CP__INP_DIS)
/* LCD Common or Segment Drive */
#define CLK_to_CP_LCD_COM_SEG            (* (reg8 *) CLK_to_CP__LCD_COM_SEG)
/* Enable Segment LCD */
#define CLK_to_CP_LCD_EN                 (* (reg8 *) CLK_to_CP__LCD_EN)
/* Slew Rate Control */
#define CLK_to_CP_SLW                    (* (reg8 *) CLK_to_CP__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define CLK_to_CP_PRTDSI__CAPS_SEL       (* (reg8 *) CLK_to_CP__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define CLK_to_CP_PRTDSI__DBL_SYNC_IN    (* (reg8 *) CLK_to_CP__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define CLK_to_CP_PRTDSI__OE_SEL0        (* (reg8 *) CLK_to_CP__PRTDSI__OE_SEL0) 
#define CLK_to_CP_PRTDSI__OE_SEL1        (* (reg8 *) CLK_to_CP__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define CLK_to_CP_PRTDSI__OUT_SEL0       (* (reg8 *) CLK_to_CP__PRTDSI__OUT_SEL0) 
#define CLK_to_CP_PRTDSI__OUT_SEL1       (* (reg8 *) CLK_to_CP__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define CLK_to_CP_PRTDSI__SYNC_OUT       (* (reg8 *) CLK_to_CP__PRTDSI__SYNC_OUT) 


#if defined(CLK_to_CP__INTSTAT)  /* Interrupt Registers */

    #define CLK_to_CP_INTSTAT                (* (reg8 *) CLK_to_CP__INTSTAT)
    #define CLK_to_CP_SNAP                   (* (reg8 *) CLK_to_CP__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins CLK_to_CP_H */


/* [] END OF FILE */
