/*******************************************************************************
* File Name: EOC_TEST.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_EOC_TEST_H) /* Pins EOC_TEST_H */
#define CY_PINS_EOC_TEST_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "EOC_TEST_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    EOC_TEST_Write(uint8 value) ;
void    EOC_TEST_SetDriveMode(uint8 mode) ;
uint8   EOC_TEST_ReadDataReg(void) ;
uint8   EOC_TEST_Read(void) ;
uint8   EOC_TEST_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define EOC_TEST_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define EOC_TEST_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define EOC_TEST_DM_RES_UP          PIN_DM_RES_UP
#define EOC_TEST_DM_RES_DWN         PIN_DM_RES_DWN
#define EOC_TEST_DM_OD_LO           PIN_DM_OD_LO
#define EOC_TEST_DM_OD_HI           PIN_DM_OD_HI
#define EOC_TEST_DM_STRONG          PIN_DM_STRONG
#define EOC_TEST_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define EOC_TEST_MASK               EOC_TEST__MASK
#define EOC_TEST_SHIFT              EOC_TEST__SHIFT
#define EOC_TEST_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define EOC_TEST_PS                     (* (reg8 *) EOC_TEST__PS)
/* Data Register */
#define EOC_TEST_DR                     (* (reg8 *) EOC_TEST__DR)
/* Port Number */
#define EOC_TEST_PRT_NUM                (* (reg8 *) EOC_TEST__PRT) 
/* Connect to Analog Globals */                                                  
#define EOC_TEST_AG                     (* (reg8 *) EOC_TEST__AG)                       
/* Analog MUX bux enable */
#define EOC_TEST_AMUX                   (* (reg8 *) EOC_TEST__AMUX) 
/* Bidirectional Enable */                                                        
#define EOC_TEST_BIE                    (* (reg8 *) EOC_TEST__BIE)
/* Bit-mask for Aliased Register Access */
#define EOC_TEST_BIT_MASK               (* (reg8 *) EOC_TEST__BIT_MASK)
/* Bypass Enable */
#define EOC_TEST_BYP                    (* (reg8 *) EOC_TEST__BYP)
/* Port wide control signals */                                                   
#define EOC_TEST_CTL                    (* (reg8 *) EOC_TEST__CTL)
/* Drive Modes */
#define EOC_TEST_DM0                    (* (reg8 *) EOC_TEST__DM0) 
#define EOC_TEST_DM1                    (* (reg8 *) EOC_TEST__DM1)
#define EOC_TEST_DM2                    (* (reg8 *) EOC_TEST__DM2) 
/* Input Buffer Disable Override */
#define EOC_TEST_INP_DIS                (* (reg8 *) EOC_TEST__INP_DIS)
/* LCD Common or Segment Drive */
#define EOC_TEST_LCD_COM_SEG            (* (reg8 *) EOC_TEST__LCD_COM_SEG)
/* Enable Segment LCD */
#define EOC_TEST_LCD_EN                 (* (reg8 *) EOC_TEST__LCD_EN)
/* Slew Rate Control */
#define EOC_TEST_SLW                    (* (reg8 *) EOC_TEST__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define EOC_TEST_PRTDSI__CAPS_SEL       (* (reg8 *) EOC_TEST__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define EOC_TEST_PRTDSI__DBL_SYNC_IN    (* (reg8 *) EOC_TEST__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define EOC_TEST_PRTDSI__OE_SEL0        (* (reg8 *) EOC_TEST__PRTDSI__OE_SEL0) 
#define EOC_TEST_PRTDSI__OE_SEL1        (* (reg8 *) EOC_TEST__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define EOC_TEST_PRTDSI__OUT_SEL0       (* (reg8 *) EOC_TEST__PRTDSI__OUT_SEL0) 
#define EOC_TEST_PRTDSI__OUT_SEL1       (* (reg8 *) EOC_TEST__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define EOC_TEST_PRTDSI__SYNC_OUT       (* (reg8 *) EOC_TEST__PRTDSI__SYNC_OUT) 


#if defined(EOC_TEST__INTSTAT)  /* Interrupt Registers */

    #define EOC_TEST_INTSTAT                (* (reg8 *) EOC_TEST__INTSTAT)
    #define EOC_TEST_SNAP                   (* (reg8 *) EOC_TEST__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins EOC_TEST_H */


/* [] END OF FILE */
