/*******************************************************************************
* File Name: EOC_TEST2.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_EOC_TEST2_H) /* Pins EOC_TEST2_H */
#define CY_PINS_EOC_TEST2_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "EOC_TEST2_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    EOC_TEST2_Write(uint8 value) ;
void    EOC_TEST2_SetDriveMode(uint8 mode) ;
uint8   EOC_TEST2_ReadDataReg(void) ;
uint8   EOC_TEST2_Read(void) ;
uint8   EOC_TEST2_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define EOC_TEST2_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define EOC_TEST2_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define EOC_TEST2_DM_RES_UP          PIN_DM_RES_UP
#define EOC_TEST2_DM_RES_DWN         PIN_DM_RES_DWN
#define EOC_TEST2_DM_OD_LO           PIN_DM_OD_LO
#define EOC_TEST2_DM_OD_HI           PIN_DM_OD_HI
#define EOC_TEST2_DM_STRONG          PIN_DM_STRONG
#define EOC_TEST2_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define EOC_TEST2_MASK               EOC_TEST2__MASK
#define EOC_TEST2_SHIFT              EOC_TEST2__SHIFT
#define EOC_TEST2_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define EOC_TEST2_PS                     (* (reg8 *) EOC_TEST2__PS)
/* Data Register */
#define EOC_TEST2_DR                     (* (reg8 *) EOC_TEST2__DR)
/* Port Number */
#define EOC_TEST2_PRT_NUM                (* (reg8 *) EOC_TEST2__PRT) 
/* Connect to Analog Globals */                                                  
#define EOC_TEST2_AG                     (* (reg8 *) EOC_TEST2__AG)                       
/* Analog MUX bux enable */
#define EOC_TEST2_AMUX                   (* (reg8 *) EOC_TEST2__AMUX) 
/* Bidirectional Enable */                                                        
#define EOC_TEST2_BIE                    (* (reg8 *) EOC_TEST2__BIE)
/* Bit-mask for Aliased Register Access */
#define EOC_TEST2_BIT_MASK               (* (reg8 *) EOC_TEST2__BIT_MASK)
/* Bypass Enable */
#define EOC_TEST2_BYP                    (* (reg8 *) EOC_TEST2__BYP)
/* Port wide control signals */                                                   
#define EOC_TEST2_CTL                    (* (reg8 *) EOC_TEST2__CTL)
/* Drive Modes */
#define EOC_TEST2_DM0                    (* (reg8 *) EOC_TEST2__DM0) 
#define EOC_TEST2_DM1                    (* (reg8 *) EOC_TEST2__DM1)
#define EOC_TEST2_DM2                    (* (reg8 *) EOC_TEST2__DM2) 
/* Input Buffer Disable Override */
#define EOC_TEST2_INP_DIS                (* (reg8 *) EOC_TEST2__INP_DIS)
/* LCD Common or Segment Drive */
#define EOC_TEST2_LCD_COM_SEG            (* (reg8 *) EOC_TEST2__LCD_COM_SEG)
/* Enable Segment LCD */
#define EOC_TEST2_LCD_EN                 (* (reg8 *) EOC_TEST2__LCD_EN)
/* Slew Rate Control */
#define EOC_TEST2_SLW                    (* (reg8 *) EOC_TEST2__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define EOC_TEST2_PRTDSI__CAPS_SEL       (* (reg8 *) EOC_TEST2__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define EOC_TEST2_PRTDSI__DBL_SYNC_IN    (* (reg8 *) EOC_TEST2__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define EOC_TEST2_PRTDSI__OE_SEL0        (* (reg8 *) EOC_TEST2__PRTDSI__OE_SEL0) 
#define EOC_TEST2_PRTDSI__OE_SEL1        (* (reg8 *) EOC_TEST2__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define EOC_TEST2_PRTDSI__OUT_SEL0       (* (reg8 *) EOC_TEST2__PRTDSI__OUT_SEL0) 
#define EOC_TEST2_PRTDSI__OUT_SEL1       (* (reg8 *) EOC_TEST2__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define EOC_TEST2_PRTDSI__SYNC_OUT       (* (reg8 *) EOC_TEST2__PRTDSI__SYNC_OUT) 


#if defined(EOC_TEST2__INTSTAT)  /* Interrupt Registers */

    #define EOC_TEST2_INTSTAT                (* (reg8 *) EOC_TEST2__INTSTAT)
    #define EOC_TEST2_SNAP                   (* (reg8 *) EOC_TEST2__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins EOC_TEST2_H */


/* [] END OF FILE */
