/*******************************************************************************
* File Name: TC_to_SP.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_TC_to_SP_H) /* Pins TC_to_SP_H */
#define CY_PINS_TC_to_SP_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "TC_to_SP_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    TC_to_SP_Write(uint8 value) ;
void    TC_to_SP_SetDriveMode(uint8 mode) ;
uint8   TC_to_SP_ReadDataReg(void) ;
uint8   TC_to_SP_Read(void) ;
uint8   TC_to_SP_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define TC_to_SP_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define TC_to_SP_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define TC_to_SP_DM_RES_UP          PIN_DM_RES_UP
#define TC_to_SP_DM_RES_DWN         PIN_DM_RES_DWN
#define TC_to_SP_DM_OD_LO           PIN_DM_OD_LO
#define TC_to_SP_DM_OD_HI           PIN_DM_OD_HI
#define TC_to_SP_DM_STRONG          PIN_DM_STRONG
#define TC_to_SP_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define TC_to_SP_MASK               TC_to_SP__MASK
#define TC_to_SP_SHIFT              TC_to_SP__SHIFT
#define TC_to_SP_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define TC_to_SP_PS                     (* (reg8 *) TC_to_SP__PS)
/* Data Register */
#define TC_to_SP_DR                     (* (reg8 *) TC_to_SP__DR)
/* Port Number */
#define TC_to_SP_PRT_NUM                (* (reg8 *) TC_to_SP__PRT) 
/* Connect to Analog Globals */                                                  
#define TC_to_SP_AG                     (* (reg8 *) TC_to_SP__AG)                       
/* Analog MUX bux enable */
#define TC_to_SP_AMUX                   (* (reg8 *) TC_to_SP__AMUX) 
/* Bidirectional Enable */                                                        
#define TC_to_SP_BIE                    (* (reg8 *) TC_to_SP__BIE)
/* Bit-mask for Aliased Register Access */
#define TC_to_SP_BIT_MASK               (* (reg8 *) TC_to_SP__BIT_MASK)
/* Bypass Enable */
#define TC_to_SP_BYP                    (* (reg8 *) TC_to_SP__BYP)
/* Port wide control signals */                                                   
#define TC_to_SP_CTL                    (* (reg8 *) TC_to_SP__CTL)
/* Drive Modes */
#define TC_to_SP_DM0                    (* (reg8 *) TC_to_SP__DM0) 
#define TC_to_SP_DM1                    (* (reg8 *) TC_to_SP__DM1)
#define TC_to_SP_DM2                    (* (reg8 *) TC_to_SP__DM2) 
/* Input Buffer Disable Override */
#define TC_to_SP_INP_DIS                (* (reg8 *) TC_to_SP__INP_DIS)
/* LCD Common or Segment Drive */
#define TC_to_SP_LCD_COM_SEG            (* (reg8 *) TC_to_SP__LCD_COM_SEG)
/* Enable Segment LCD */
#define TC_to_SP_LCD_EN                 (* (reg8 *) TC_to_SP__LCD_EN)
/* Slew Rate Control */
#define TC_to_SP_SLW                    (* (reg8 *) TC_to_SP__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define TC_to_SP_PRTDSI__CAPS_SEL       (* (reg8 *) TC_to_SP__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define TC_to_SP_PRTDSI__DBL_SYNC_IN    (* (reg8 *) TC_to_SP__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define TC_to_SP_PRTDSI__OE_SEL0        (* (reg8 *) TC_to_SP__PRTDSI__OE_SEL0) 
#define TC_to_SP_PRTDSI__OE_SEL1        (* (reg8 *) TC_to_SP__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define TC_to_SP_PRTDSI__OUT_SEL0       (* (reg8 *) TC_to_SP__PRTDSI__OUT_SEL0) 
#define TC_to_SP_PRTDSI__OUT_SEL1       (* (reg8 *) TC_to_SP__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define TC_to_SP_PRTDSI__SYNC_OUT       (* (reg8 *) TC_to_SP__PRTDSI__SYNC_OUT) 


#if defined(TC_to_SP__INTSTAT)  /* Interrupt Registers */

    #define TC_to_SP_INTSTAT                (* (reg8 *) TC_to_SP__INTSTAT)
    #define TC_to_SP_SNAP                   (* (reg8 *) TC_to_SP__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins TC_to_SP_H */


/* [] END OF FILE */
